# coding: utf-8

"""
    Planetary Data System API

    Federated PDS API which provides actionable end points standardized between the different nodes.   # noqa: E501

    The version of the OpenAPI document: main
    Contact: pds-operator@jpl.nasa.gov
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from pds.api_client.configuration import Configuration


class Pds4Metadata(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'node_name': 'str',
        'label_file': 'Pds4MetadataLabelFile',
        'data_files': 'list[Pds4MetadataDataFiles]'
    }

    attribute_map = {
        'node_name': 'node_name',
        'label_file': 'label_file',
        'data_files': 'data_files'
    }

    def __init__(self, node_name=None, label_file=None, data_files=None, local_vars_configuration=None):  # noqa: E501
        """Pds4Metadata - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._node_name = None
        self._label_file = None
        self._data_files = None
        self.discriminator = None

        if node_name is not None:
            self.node_name = node_name
        if label_file is not None:
            self.label_file = label_file
        if data_files is not None:
            self.data_files = data_files

    @property
    def node_name(self):
        """Gets the node_name of this Pds4Metadata.  # noqa: E501


        :return: The node_name of this Pds4Metadata.  # noqa: E501
        :rtype: str
        """
        return self._node_name

    @node_name.setter
    def node_name(self, node_name):
        """Sets the node_name of this Pds4Metadata.


        :param node_name: The node_name of this Pds4Metadata.  # noqa: E501
        :type node_name: str
        """

        self._node_name = node_name

    @property
    def label_file(self):
        """Gets the label_file of this Pds4Metadata.  # noqa: E501


        :return: The label_file of this Pds4Metadata.  # noqa: E501
        :rtype: Pds4MetadataLabelFile
        """
        return self._label_file

    @label_file.setter
    def label_file(self, label_file):
        """Sets the label_file of this Pds4Metadata.


        :param label_file: The label_file of this Pds4Metadata.  # noqa: E501
        :type label_file: Pds4MetadataLabelFile
        """

        self._label_file = label_file

    @property
    def data_files(self):
        """Gets the data_files of this Pds4Metadata.  # noqa: E501


        :return: The data_files of this Pds4Metadata.  # noqa: E501
        :rtype: list[Pds4MetadataDataFiles]
        """
        return self._data_files

    @data_files.setter
    def data_files(self, data_files):
        """Sets the data_files of this Pds4Metadata.


        :param data_files: The data_files of this Pds4Metadata.  # noqa: E501
        :type data_files: list[Pds4MetadataDataFiles]
        """

        self._data_files = data_files

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Pds4Metadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Pds4Metadata):
            return True

        return self.to_dict() != other.to_dict()
